import asyncio
import requests
import urllib.request
import shutil
from rubpy import Client
from rubpy.types import Update
import os

async def download_video(url, file_name):
    with urllib.request.urlopen(url) as response, open(file_name, 'wb') as out_file:
        shutil.copyfileobj(response, out_file) 

async def main():
    client = Client('app')

    api_url = 'https://publisher.metafilm.ir/Content/Get/083d0854-61ce-4ae9-b383-e143c6c023b0/10/1'
    response = requests.get(api_url)
    data = response.json()
    movies = data['movies']

    for movie in movies:
        title_farsi = movie['farsiPureTitle']
        title = movie['pureTitle']
        year = movie['creationYear']
        for file_info in movie['files']:
            key = file_info['key']
            if 'HS' in key:
                file_size = file_info['fileSize']
                url = file_info['url']
                print(f"Key: {key}, File Size: {file_size}, \n link {key} = {url}")
                file_names = f"{title}.{year}.{key}.mp4"
                file_name = file_names.replace(" ", ".")
                print(file_name)
                await download_video(url, file_name)
                guid = 'c0BvdTb0eba14d0bfd1cc79a75ccb33d'
                quality = key.replace("HSHD", "")
                caption = f":fire: فیلم {title_farsi} \n :us: {title} {year} \n کیفیت: {quality} "
                # print(caption)
                # masir = "C:\\Users\\Administrator\\Downloads"
                # add_masir = f"\\{title_2}.{year}.{key}.mp4"
                # filemasi = (masir + add_masir)
                # filemasir = filemasi.replace('////', '//')
                title_2 = title.replace(" ", ".")
                masir = "C:\\Users\\Administrator\\Downloads"
                add_masir = f"{title_2}.{year}.{key}.mp4"
                filemasir = os.path.join(masir, add_masir)
                print(f"filemasir: {filemasir}")
                print("uploading...")
                await client.send_video(guid, filemasir, caption)
                print(f"finished...{file_name}")
                print("----------------------------")
    await client.run()

if __name__ == "__main__":
    asyncio.run(main())
